/* ************************ SCI.H *****************************
 * Jonathan W. Valvano     1/15/04
 * Modified from EE345L students Charlie Gough && Matt Hawk
 * Modified by EE345M students Agustinus Darmawan + Mingjie Qiu
 * Simple I/O routines to SCI0 serial port 
 * ************************************************************ */
 
// Copyright 2004 by Jonathan W. Valvano, valvano@mail.utexas.edu 
//    You may use, edit, run or distribute this file 
//    as long as the above copyright notice remains 

/* ASCII symbols 
     CR = carriage return 
     LF = line feed 
     BS = backspace 
     SP = space 
 */
#define CR   0x0D
#define LF   0x0A
#define BS   0x08
#define ESC  0x1B
#define SP   0x20       
#define DEL  0x7F


//------------Initialization-------------------------------------
// Possible rates
// br =  2400 bits/sec
// br =  4800 bits/sec
// br =  9600 bits/sec
// br =  19200 bits/sec
// br =  38400 bits/sec
// br =  500000 bits/sec
void SCI_Init(unsigned short br);  
 
//--------------Input/Receive from serial port-------------------
unsigned char SCI_InChar(void);     // Reads in a character, gadfly 
void SCI_InString(unsigned char *, unsigned short); // Reads in a String of max length
unsigned short SCI_InUDec(void);    // Reads in an Unsigned 16 bit Decimal number
unsigned short SCI_InUHex(void);    // Reads in an Unsigned 16 bit Hexadecimal number
unsigned char SCI_InStatus(void);   // Returns true if a call to InChar will return right away

//--------------Output/Transmit to serial port-------------------
unsigned char SCI_OutStatus(void);   // Returns true if a call to OutChar will return right away
void SCI_OutChar(unsigned char);     // Output an 8-bit character, gadfly 
void SCI_OutUDec(unsigned short);    // Output as 16-bit unsigned decimal 
void SCI_OutString(unsigned char *); // Output a string, null terminated 
void SCI_OutUHex(unsigned short);    // Outputs an Unsigned 16 bit Hexadecimal number



