// filename ******** Main.C ************** 
// Example main program for SCI 68HC812A4 gadlfy example   
// SCI0 connected to PC COM port
//    Jonathan W. Valvano 1/15/04

#include <hidef.h>         /* common defines and macros */
#include <mc68hc812a4.h>   /* derivative information */
#include "SCI.h"

#pragma LINK_INFO DERIVATIVE "hc12a4"

// These variables should be local, but
// I placed as global to assist in debugging
unsigned char string[10];  
unsigned short n;
const unsigned char Welcome[]
="TechArts Adapt812A4, Metrowerks SCI demo  1/15/04 -JWV";
//**************Init**************
// Initialize PortT and timer
void Init(void){
  COPCTL = 0x00;    // disable COP 
  DDRT |= 0x40;     // PortT bit 6 is output to LED
  TSCR = 0x80;      // TEN(enable)
}

//*****************OutCRLF***************
// Output a CR,LF to go to a new line
// toggle PortT bit 6 each time, debugging profile
void OutCRLF(void){
  SCI_OutChar(CR);
  SCI_OutChar(LF);
  PORTT ^= 0x40;          // toggle bit 6
}

void main(void) {
  Init();     // initialize COP, Port T 
  SCI_Init(38400);
  SCI_OutString(Welcome); OutCRLF();

  for(;;) {
    SCI_OutString("InString: "); 
    SCI_InString(string,9);   
    SCI_OutString(" OutString="); SCI_OutString(string); OutCRLF();
    
    SCI_OutString("InUDec: ");  n=SCI_InUDec(); 
    SCI_OutString(" OutUDec="); SCI_OutUDec(n); OutCRLF();
     
    SCI_OutString("InUHex: ");  n=SCI_InUHex(); 
    SCI_OutString(" OutUHex="); SCI_OutUHex(n); OutCRLF();
  } 
}
